CREATE USER 'awesome'@'localhost' IDENTIFIED WITH mysql_native_password BY '123456';
GRANT ALL PRIVILEGES ON awesome.* TO 'awesome'@'localhost' WITH GRANT OPTION;
flush privileges;

CREATE DATABASE IF NOT EXISTS awesome DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci;
use awesome;

CREATE TABLE `users` (
  `uid` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `email` varchar(50) NOT NULL,
  `passwd` char(32) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL DEFAULT '',
  `admin` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0普通用户,1管理员,2游客',
  `name` varchar(50) NOT NULL,
  `birthday` DATE COMMENT'用户生日',
  `user_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0正常,1异常,2冻结',
  `image` varchar(500) NOT NULL DEFAULT 'about:blank' COMMENT '头像,base64 encode in file',
  -- `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `created_by` int(11) unsigned COMMENT '创建人uid',
  `updated_by` int(11) unsigned COMMENT '修改人uid',
  `is_deleted` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1代表逻辑删除',
  PRIMARY KEY (`uid`),
  UNIQUE KEY `emailxDel` (`email`,`is_deleted`),
  UNIQUE KEY `namexDel` (`name`,`is_deleted`),
  KEY `index_created_at` (`created_at`)
) ENGINE=InnoDB AUTO_INCREMENT=100 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO users(`email`, `passwd`, `admin`, `name`) value('admin@z417.top', md5('admin'), 1, '管理员');
UPDATE users SET created_by=(SELECT a.uid from (SELECT `uid` FROM users WHERE `admin`=1) AS a), updated_by=(SELECT a.uid from (SELECT `uid` FROM users WHERE `admin`=1) AS a);
ALTER table users add CONSTRAINT `fk_self_uidxCre` FOREIGN KEY(`created_by`) REFERENCES users(`uid`);
ALTER table users add CONSTRAINT `fk_self_uidxUpd` FOREIGN KEY(`updated_by`) REFERENCES users(`uid`);
